<template>
  <input class="input"
    :placeholder="placeholder"
    :type="type"
    :name="name"
    v-model="inputValue"
  >
  <div class="message-container">
    <error-message v-show="isError" :message="message" />
  </div>
</template>

<script>
import ErrorMessage from '@/components/ui/ErrorMessage'
import { ref, watchEffect } from 'vue'
import { useStore } from 'vuex'

export default {
  components: { ErrorMessage },
  props: {
    type: {
      type: String,
      default: 'text'
    },
    name: {
      type: String,
      default: 'login'
    },
    placeholder: {
      type: String,
      default: 'Логин'
    },
    isError: {
      type: Boolean,
      default: false
    },
    message: {
      type: String,
      default: ''
    }
  },
  setup (props) {
    const store = useStore()
    const inputValue = ref('')
    watchEffect(() => {
      console.log('inputValue', inputValue.value)
      store.commit('SetInputValue', {
        inputName: props.name,
        inputValue: inputValue.value
      })
    })
    return {
      inputValue
    }
  }
}
</script>

<style lang="scss" scoped>
.input {
  padding: 0 20px;
  width: 420px;
  height: 40px;
  border: 1px solid #D58C51;
  border-radius: 61px;
}

.message-container {
  margin-top: 3px;
  padding-left: 18px;
  height: 10px;
}
</style>
